// Debug
mobjinfo[MT_CYBRAKDEMON].spawnhealth = 1
G_SetUsedCheats(false)

freeslot(
	"MT_FINALBRAK",
	"MT_ASTEROID",
	"MT_ASTEROIDMAKER",
	"S_FINALBRAK_IDLE",
	"S_FINALBRAK_PAIN_1",
	"S_FINALBRAK_DEAD_1",
	"S_FINALBRAK_DEAD_2",
	"S_FINALBRAK_DEAD_3",
	"S_ASTEROID",
	"S_ASTEROIDMAKER"
)

function A_FinalBrak_Move(mo,a,b)
	mo.angle = R_PointToAngle2(mo.x,mo.y,a,mo.y+b)
	
	local found = nil
	searchBlockmap("objects",function(r,f)
		if (f.player
		or (f.type == MT_ASTEROID
		and f.z < r.height))
		and R_PointToDist2(f.x,f.y,r.x,r.y) <= 600*FU
		and (not found
		or R_PointToDist2(f.x,f.y,r.x,r.y) < R_PointToDist2(found.x,found.y,r.x,r.y))
			found = f
		end
	end,mo,mo.x-(600*FU),mo.x+(600*FU),mo.y-(600*FU),mo.y+(600*FU))
	
	if found
	and mo.y > 1500*FU
		mo.angle = R_PointToAngle2(mo.x,mo.y,mo.x,mo.y+b)
		
		local dodgeAngle = 0
		if abs(mo.x) >= 500*FU
			dodgeAngle = mo.x/-abs(mo.x)
		elseif mo.x != found.x
			dodgeAngle = (mo.x-found.x)/abs(mo.x-found.x)
		elseif mo.x != a
			dodgeAngle = (mo.x-a)/abs(mo.x-a)
		else
			if P_RandomChance(FRACUNIT/2)
				dodgeAngle = 1
			else
				dodgeAngle = -1
			end
		end
		
		mo.momx = $+(mo.info.speed*dodgeAngle)
	else	
		P_Thrust(mo,mo.angle,mo.info.speed)
	end
	
	P_InstaThrust(mo,R_PointToAngle2(0,0,mo.momx,mo.momy),min(FixedHypot(mo.momx,mo.momy),60*FU))
end

function A_FinalBrak_Die(mo,a,b)
	mo.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
	S_StartSound(nil,sfx_s3k9f)
	S_StartSound(nil,sfx_supert)
	
	for p in players.iterate
		if p.mo and p.mo.valid
			/*p.mo.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT*/
			P_MoveOrigin(p.mo,p.mo.x,-128*FU,FU)
			P_InstaThrust(p.mo,0,0)
			p.mo.state = S_PLAY_FALL
			p.superfinalflash = 8
			S_PauseMusic(p)
		end 
	end
	
	P_SetOrigin(mo,mo.x,0,FU)
	P_InstaThrust(mo,ANGLE_90,30*FU)
	
	G_SetCustomExitVars(nil,1)
	A_ForceWin(mo,0,0)

	mo.subsector.sector.floorheight = -4096*FU
	mo.momz = -10*FU
end

function A_MakeAsteroid(mo,a,b)
	local asteroid = P_SpawnMobj(P_RandomRange(a,b)*FU,mo.y,P_RandomKey(256)*FU,MT_ASTEROID)
	asteroid.momy = P_RandomRange(8,32)*-FU
	asteroid.scale = P_RandomRange(10,40)*FU/20
	mo.tics = P_RandomKey(4)+1
end

mobjinfo[MT_FINALBRAK] = {
	doomednum = 3330,
	spawnstate = S_FINALBRAK_IDLE,
	spawnhealth = 25,
	seestate = S_FINALBRAK_IDLE,
	painstate = S_FINALBRAK_PAIN_1,
	deathstate = S_FINALBRAK_DEAD_1,
	painsound = sfx_dmpain,
	deathsound = sfx_s3kb4,
	radius = 48*FU,
	height = 160*FU,
	speed = FU,
	flags = MF_SPECIAL|MF_BOSS|MF_SHOOTABLE|MF_SLIDEME
}

mobjinfo[MT_ASTEROID] = {
	spawnstate = S_ASTEROID,
	spawnhealth = 1,
	deathstate = S_XPLD1,
	deathsound = sfx_crumbl,
	radius = 16*FU,
	height = 16*FU,
	speed = 4*FU,
	flags = MF_SPECIAL|MF_ENEMY|MF_SHOOTABLE|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

mobjinfo[MT_ASTEROIDMAKER] = {
	doomednum = 3331,
	spawnstate = S_ASTEROIDMAKER,
	spawnhealth = 1000,
	radius = 16*FU,
	height = 16*FU,
	speed = 4*FU,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

states[S_FINALBRAK_IDLE] = {
	sprite = SPR_BRAK,
	frame = N,
	tics = 1,
	action = A_FinalBrak_Move,
	var1 = 0,
	var2 = 128*FU,
	nextstate = S_FINALBRAK_IDLE
}

states[S_FINALBRAK_PAIN_1] = {
	sprite = SPR_BRAK,
	frame = N,
	tics = 35,
	action = A_Pain,
	nextstate = S_FINALBRAK_IDLE
}

states[S_FINALBRAK_DEAD_1] = {
	sprite = SPR_BRAK,
	frame = N,
	tics = 0,
	action = A_FinalBrak_Die,
	nextstate = S_FINALBRAK_DEAD_2
}

states[S_FINALBRAK_DEAD_2] = {
	sprite = SPR_BRAK,
	frame = N,
	tics = 1,
	action = A_BossScream,
	nextstate = S_FINALBRAK_DEAD_2
}

states[S_ASTEROIDMAKER] = {
	sprite = SPR_NONE,
	tics = 1,
	action = A_MakeAsteroid,
	var1 = -600,
	var2 = 600,
	nextstate = S_ASTEROIDMAKER
}

states[S_ASTEROID] = {
	sprite = SPR_ROIJ,
	frame = A|FF_ANIMATE,
	tics = -2,
	var1 = 4,
	var2 = 4,
	nextstate = S_NULL
}

addHook("MobjDamage",function(t,i,s,d,dt)
	if t and s and t.valid and s.valid and s.player
		P_InstaThrust(s,ANGLE_90,-60*FU)
		P_SetObjectMomZ(s,10*FU,false)
		P_GivePlayerRings(s.player,3)
		S_StartSound(nil,sfx_itemup,s.player)
	end
end, MT_FINALBRAK)

addHook("PlayerThink",function(p)
	
	if not mapheaderinfo[gamemap].issuperfinal
		return end
	
	//Tails jails (jails for Tails)
	if p.bot 
	and p.mo and p.mo.valid
		P_SetOrigin(p.mo,1248*FU,-864*FU,0)
		return end
	
	if skins[p.skin].name != "sonic"
		R_SetPlayerSkin(p,"sonic")
	end
	
	if p.superfinalflash
		p.superfinalflash = $-1
	end
	
	if p.exiting
	and p.mo and p.mo.valid
		P_MoveOrigin(p.mo,p.mo.x,-128*FU,p.mo.z)
		P_InstaThrust(p.mo,0,0)
	end
	
end)

hud.add(function(v,p,cam)
	if p.superfinalflash
		v.drawFill(-64,-64,2*v.width(),2*v.height(),0)
	end
end)

addHook("MobjThinker",function(mo)
	if mo.z < -1500
		mo.state = S_NULL
	end
end,MT_ASTEROID)

addHook("MobjDeath",function(t,i,s,dt)
	if t and s and t.valid and s.valid and s.player
		P_InstaThrust(s,ANGLE_90,FixedMul(-t.scale,s.player.speed))
		P_SetObjectMomZ(s,10*FU,false)
	end
end, MT_ASTEROID)

addHook("PlayerSpawn",function(p)
	if mapheaderinfo[gamemap].issuperfinal
	and not p.bot
		if not All7Emeralds(emeralds)
			G_SetUsedCheats(false)
			emeralds = (1<<8)-1
		end
		
		if skins[p.skin].name != "sonic"
			G_SetUsedCheats(false)
			R_SetPlayerSkin(p,"sonic")
		end
		
		P_DoSuperTransformation(p,true)
	end
end)

addHook("MapLoad",function()
	if gamemap == 27
		if not (netgame or splitscreen)
		and players[0].skin == 0
		and All7Emeralds(emeralds)
			G_SetCustomExitVars(28,1)
		else
			G_SetCustomExitVars(nil,1)
		end
	end
end)